/***************************************************************************
                          lconfig.cpp  -  description
                             -------------------
    begin                : Fri Jan 17 2003
    copyright            : (C) 2003 by Sheldon Lee Wen
    email                : leewsb@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "lconfig.h"
#include "functions.h"

using namespace lineak_util_functions;

LConfig::LConfig() {

//	kbdtype = null;
//	cdrom = DEFAULT_CDROM_DEVICE;
//	mixer = DEFAULT_MIXER_DEVICE;
//	conffilename = null;

	directives.addValue("KeyboardType", null);
	directives.addValue("CdromDevice", DEFAULT_CDROM_DEVICE);
	directives.addValue("MixerDevice", DEFAULT_MIXER_DEVICE);
	directives.addValue("Screensaver", null);
	directives.addValue("conffilename", null);

  #ifdef HAVE_XOSD
  directives.addValue("XOSD_font", XOSD_FONT);
  directives.addValue("XOSD_color", XOSD_COLOR);
  directives.addValue("XOSD_pos", XOSD_POS);
  directives.addValue("XOSD_align", XOSD_ALIGN);
  directives.addValue("XOSD_timeout", XOSD_TIMEOUT);
  directives.addValue("XOSD_hoffset", XOSD_HOFFSET);
  directives.addValue("XOSD_voffset", XOSD_VOFFSET);
  directives.addValue("XOSD_soffset", XOSD_SOFFSET);

  /** Set the XOSD values to lineakd defaults */
//  XOSD_font = XOSD_FONT;
//  XOSD_color = XOSD_COLOR;
//  XOSD_timeout = XOSD_TIMEOUT;
//  XOSD_pos = XOSD_POS;
//  XOSD_align = XOSD_ALIGN;
//  XOSD_hoffset = XOSD_HOFFSET;
//  XOSD_voffset = XOSD_VOFFSET;
//  XOSD_soffset = XOSD_SOFFSET;
  #endif
}
LConfig::LConfig(const LConfig & rhs) {
	if (this != &rhs) {
		comtable.clear();
		//kbdtype = rhs.kbdtype;
		//cdrom = rhs.cdrom;
		//mixer = rhs.mixer;
		//conffilename = rhs.conffilename;
		comtable = rhs.comtable;
//    #ifdef HAVE_XOSD
//    XOSD_font = rhs.XOSD_font;
//    XOSD_color = rhs.XOSD_color;
//    XOSD_timeout = rhs.XOSD_timeout;
//    XOSD_pos = rhs.XOSD_pos;
//    XOSD_align = rhs.XOSD_align;
//    XOSD_hoffset = rhs.XOSD_hoffset;
//    XOSD_voffset = rhs.XOSD_voffset;
//    XOSD_soffset = rhs.XOSD_soffset;
//    #endif
    directives = rhs.directives; 
	}
}
LConfig & LConfig::operator=(const LConfig & rhs) {
	if (this != &rhs) {
		comtable.clear();
		//kbdtype = rhs.kbdtype;
		//cdrom = rhs.cdrom;
		//mixer = rhs.mixer;
		//conffilename = rhs.conffilename;
		comtable = rhs.comtable;
//    #ifdef HAVE_XOSD
//    XOSD_font = rhs.XOSD_font;
//    XOSD_color = rhs.XOSD_color;
//    XOSD_timeout = rhs.XOSD_timeout;
//    XOSD_pos = rhs.XOSD_pos;
//    XOSD_align = rhs.XOSD_align;
//    XOSD_hoffset = rhs.XOSD_hoffset;
//    XOSD_voffset = rhs.XOSD_voffset;
//    XOSD_soffset = rhs.XOSD_soffset;
//    #endif
    directives = rhs.directives;
    
	}
	return *this;
}
LConfig::LConfig(ConfigDirectives &dirs) {

	directives = dirs;
//	string cdrom = directives["CdromDevice"];
	//kbdtype = directives["KeyboardType"];
//	string mixer = directives["MixerDevice"];
//	screensaver = directives["Screensaver"];
	
	if (directives["CdromDevice"] == null)
		directives["CdromDevice"] = DEFAULT_CDROM_DEVICE;
	if (directives["MixerDevice"] == null)
		directives["MixerDevice"] = DEFAULT_MIXER_DEVICE;

//  #ifdef HAVE_XOSD
//  XOSD_font = directives["XOSD_font"];
//  XOSD_color = directives["XOSD_color"];
//  XOSD_pos = (xosd_pos)directives.getIntValue("XOSD_pos");
//  XOSD_align = (xosd_align)directives.getIntValue("XOSD_align");
//  XOSD_timeout = directives.getIntValue("XOSD_timeout");
//  XOSD_hoffset = directives.getIntValue("XOSD_hoffset");
//  XOSD_voffset = directives.getIntValue("XOSD_voffset");
//  XOSD_soffset = directives.getIntValue("XOSD_soffset");
//  #endif

}

LConfig::LConfig(string ikbdtype, string icdrom, string imixer) {
	if (icdrom == null)
		directives.addValue("CdromDevice", DEFAULT_CDROM_DEVICE);
	else
		directives.addValue("CdromDevice", icdrom);
	
	if (imixer == null)
		directives.addValue("MixerDevice", DEFAULT_MIXER_DEVICE);
	else
		directives.addValue("MixerDevice", imixer);
	
	directives.addValue("KeyboardType", ikbdtype);
	directives.addValue("Screensaver", null);

  #ifdef HAVE_XOSD
   /** Set the XOSD values to lineakd defaults */
//  XOSD_font = XOSD_FONT;
//  XOSD_color = XOSD_COLOR;
//  XOSD_timeout = XOSD_TIMEOUT;
//  XOSD_pos = XOSD_POS;
//  XOSD_align = XOSD_ALIGN;
//  XOSD_hoffset = XOSD_HOFFSET;
//  XOSD_voffset = XOSD_VOFFSET;
//  XOSD_soffset = XOSD_SOFFSET;
  
  directives.addValue("XOSD_font", XOSD_FONT);
  directives.addValue("XOSD_color", XOSD_COLOR);
  directives.addValue("XOSD_pos", (int)XOSD_POS);
  directives.addValue("XOSD_align", (int)XOSD_ALIGN);
  directives.addValue("XOSD_timeout", XOSD_TIMEOUT);
  directives.addValue("XOSD_hoffset", XOSD_HOFFSET);
  directives.addValue("XOSD_voffset", XOSD_VOFFSET);
  directives.addValue("XOSD_soffset", XOSD_SOFFSET);
  #endif

}
LConfig::~LConfig(){
}
/** Return a list of keynames */
const Vector& LConfig::getKeyNames(){
	vec.clear();
	for (HashIter i = comtable.begin(); i != comtable.end(); i++)
		vec.push_back(i->first);
	return vec;
}
/** Return a map of commands indexed by keycodes. */
IKeyTable LConfig::getCommandIndex(const SKeyTable& skeys) {
	IKeyTable table;
	string comm;
	for ( SKeyTableIter i = skeys.begin(); i != skeys.end(); i++ ) 
		table[(i->second).keycode] = comtable[i->first];
	return (table);
}
/** Return a map of commands indexed by keycodes. */
IKeyTable LConfig::getCommandIndex(const LKbd& keyboard) {
	return (getCommandIndex(keyboard.getKeys()));
}
LCommand& LConfig::getCommand(string key) {
	return comtable[key];
}
void LConfig::setCommand(string key, LCommand command) {
	comtable[key] = command;
}
void LConfig::addKey(string key, LCommand command, bool respect_toggle) {
//  cout << "Setting command\n";
//  lineak_util_functions::inspect_vector(command.getArgs());
	if (!respect_toggle)
		setCommand(key, command);
		
}
string LConfig::getValue(string key) const {
	return directives.getValue(key);
}
void LConfig::setValue(string key, string value) {
	directives.addValue(key,value);
}
int LConfig::getIntValue(string key) const {
	return directives.getIntValue(key);
}
void LConfig::setValue(string key, int value) {
	directives.addValue(key,value);
}

void LConfig::setFilename(string file) {
	directives.addValue("conffilename", file);
}
bool LConfig::isEmpty(){
	string kbdtype = directives.getValue("KeyboardType");
	string conffilename = directives.getValue("conffilename");
	return (comtable.empty() || (kbdtype == null && conffilename == null));
}

void LConfig::print(ostream &out) const {
      
    out << CONF_HEADER;
    out << "KeyboardType = " << directives.getValue("KeyboardType") << endl;
   	out << "CdromDevice = " << directives.getValue("CdromDevice") << endl;
   	out << "MixerDevice = " << directives.getValue("MixerDevice") << endl;
   	out << "Screensaver = " << directives.getValue("Screensaver") << endl;

    #ifdef HAVE_XOSD
    string pos, align;
    xosd_pos XOSD_pos = (xosd_pos)directives.getIntValue("XOSD_pos");
    xosd_align XOSD_align = (xosd_align)directives.getIntValue("XOSD_align");
    // Save our enums back as strings.
    if (XOSD_pos == XOSD_top)
      pos = "top";
    if (XOSD_pos == XOSD_middle)
      pos = "middle";
    if (XOSD_pos == XOSD_bottom)
      pos = "bottom";
    if (XOSD_align == XOSD_left)
      align = "left";
    if (XOSD_align == XOSD_center)
      align = "center";
    if (XOSD_align == XOSD_right)
      align = "right";

    out << "XOSD_font = " << directives.getValue("XOSD_font") << endl;
    out << "XOSD_color = " << directives.getValue("XOSD_color")  << endl;
    out << "XOSD_timeout = " << directives.getIntValue("XOSD_timeout") << endl;
    
    out << "XOSD_pos = " << pos << endl;
    out << "XOSD_align = " << align << endl;
    
    out << "XOSD_hoffset = " << directives.getIntValue("XOSD_hoffset") << endl;
    out << "XOSD_voffset = " << directives.getIntValue("XOSD_voffset") << endl;
    out << "XOSD_soffset = " << directives.getIntValue("XOSD_soffset") << endl;
    #endif

    out << endl;
    string command;
    LCommand comm;
		for (HashIter i = comtable.begin(); i != comtable.end(); i++ ) {
        comm = i->second;
        command = comm.getCommand();
        if (command == null)
          command = "";
		out << i->first << " = " << command << endl;
    }
}
